local PrincessTower = ...

-- Apply building asset processor
PrincessTower:registerAssetProcessor("models/princessTower.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})

-- Register common prefab nodes
PrincessTower:registerAssetId("models/princessTower.fbx/Prefab/princessTower/princessRootPart", "PRINCESS_TOWER_ROOT_PREFAB")
PrincessTower:registerAssetId("models/princessTower.fbx/Prefab/princessTower/princessRootPart/princessDoorPart", "PRINCESS_TOWER_DOOR_PREFAB")

-- Register the princess tower part
PrincessTower:register({
	DataType = "BUILDING_PART",
	Id = _PrincessPrefix .. "_TOWER_ROOT_PART",
	Name = _PrincessPrefix .. "_TOWER_ROOT_NAME",
	Description = _PrincessPrefix .. "_TOWER_ROOT_DESC",
	Category = "CORE",
        BuildingZone = { ZoneEntryList = {
            { Polygon = polygon.createCircle( 2, { 0, 0 }, 8 ),
              Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } }
        }},
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = _PrincessPrefix .. "_TOWER_ROOT_PREFAB"
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "STONE", Quantity = _NoSandbox*5 }
		}
	},
	AssetBuildingFunction = _PrincessPrefix .. "_TOWER_ROOT"
})

PrincessTower:register({
		DataType = "BUILDING_FUNCTION_WORKPLACE",
                Id = _PrincessPrefix .. "_TOWER_ROOT",
		WorkerCapacity = 1,
                RelatedJob = { Job = _PrincessPrefix, Behavior = "BEHAVIOR_WORK" }
})

-- Register flag assigner component on the collider's type to 'PLATFORM'
PrincessTower:configurePrefabFlagList("models/princessTower.fbx/Prefab/princessTower/princessRootPart", { "PLATFORM" })

-- Register grounding components
PrincessTower:registerPrefabComponent("models/princessTower.fbx/Prefab/princessTower/princessRootPart/princessDoorPart", {
	DataType = "COMP_GROUNDED"
})

-- Register air vent particle system (rope)
PrincessTower:registerAssetId("models/princessTower.fbx/Prefab/princessTower/princessRootPart/RopeEmitter_princess", _PrincessPrefix .. "_TOWER_ROPE_EMITTER_PREFAB")

PrincessTower:registerPrefabComponent("models/princessTower.fbx/Prefab/princessTower/princessRootPart", {
	DataType = "COMP_BUILDING_PART",
	FeedbackComponentListToActivate = {
                 { _PrincessPrefix .. "_TOWER_ROPE_EMITTER_PREFAB", "COMP_PARTICLE_EMITTER_TOGGLE" }
	}
})

PrincessTower:registerPrefabComponent("models/princessTower.fbx/Prefab/princessTower/princessRootPart/RopeEmitter_princess", {
	DataType = "COMP_PARTICLE_EMITTER",
	ParticleSystem = _RopePrefix .. "_PARTICLE_SYSTEM",
	IsPlaying = true,
	IsEmitting = false
})

PrincessTower:registerPrefabComponent("models/princessTower.fbx/Prefab/princessTower/princessRootPart/RopeEmitter_princess", {
	DataType = "COMP_PARTICLE_EMITTER_TOGGLE",
	Enabled = false
})
